/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package io.asouquieres.avromodel;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

/** Customer model */
@org.apache.avro.specific.AvroGenerated
public class Customer extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 1603618008895829434L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Customer\",\"namespace\":\"io.asouquieres.avromodel\",\"doc\":\"Customer model\",\"fields\":[{\"name\":\"id\",\"type\":\"long\"},{\"name\":\"commonName\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"postalCode\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"adress\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"inscriptionDate\",\"type\":{\"type\":\"long\",\"logicalType\":\"timestamp-millis\"}}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();
static {
    MODEL$.addLogicalTypeConversion(new org.apache.avro.data.TimeConversions.TimestampMillisConversion());
  }

  private static final BinaryMessageEncoder<Customer> ENCODER =
      new BinaryMessageEncoder<Customer>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Customer> DECODER =
      new BinaryMessageDecoder<Customer>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<Customer> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<Customer> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<Customer> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<Customer>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this Customer to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a Customer from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a Customer instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static Customer fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

   private long id;
   private java.lang.String commonName;
   private java.lang.String postalCode;
   private java.lang.String adress;
   private java.time.Instant inscriptionDate;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Customer() {}

  /**
   * All-args constructor.
   * @param id The new value for id
   * @param commonName The new value for commonName
   * @param postalCode The new value for postalCode
   * @param adress The new value for adress
   * @param inscriptionDate The new value for inscriptionDate
   */
  public Customer(java.lang.Long id, java.lang.String commonName, java.lang.String postalCode, java.lang.String adress, java.time.Instant inscriptionDate) {
    this.id = id;
    this.commonName = commonName;
    this.postalCode = postalCode;
    this.adress = adress;
    this.inscriptionDate = inscriptionDate.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
  }

  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return commonName;
    case 2: return postalCode;
    case 3: return adress;
    case 4: return inscriptionDate;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  private static final org.apache.avro.Conversion<?>[] conversions =
      new org.apache.avro.Conversion<?>[] {
      null,
      null,
      null,
      null,
      new org.apache.avro.data.TimeConversions.TimestampMillisConversion(),
      null
  };

  @Override
  public org.apache.avro.Conversion<?> getConversion(int field) {
    return conversions[field];
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.Long)value$; break;
    case 1: commonName = value$ != null ? value$.toString() : null; break;
    case 2: postalCode = value$ != null ? value$.toString() : null; break;
    case 3: adress = value$ != null ? value$.toString() : null; break;
    case 4: inscriptionDate = (java.time.Instant)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return The value of the 'id' field.
   */
  public long getId() {
    return id;
  }


  /**
   * Sets the value of the 'id' field.
   * @param value the value to set.
   */
  public void setId(long value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'commonName' field.
   * @return The value of the 'commonName' field.
   */
  public java.lang.String getCommonName() {
    return commonName;
  }


  /**
   * Sets the value of the 'commonName' field.
   * @param value the value to set.
   */
  public void setCommonName(java.lang.String value) {
    this.commonName = value;
  }

  /**
   * Gets the value of the 'postalCode' field.
   * @return The value of the 'postalCode' field.
   */
  public java.lang.String getPostalCode() {
    return postalCode;
  }


  /**
   * Sets the value of the 'postalCode' field.
   * @param value the value to set.
   */
  public void setPostalCode(java.lang.String value) {
    this.postalCode = value;
  }

  /**
   * Gets the value of the 'adress' field.
   * @return The value of the 'adress' field.
   */
  public java.lang.String getAdress() {
    return adress;
  }


  /**
   * Sets the value of the 'adress' field.
   * @param value the value to set.
   */
  public void setAdress(java.lang.String value) {
    this.adress = value;
  }

  /**
   * Gets the value of the 'inscriptionDate' field.
   * @return The value of the 'inscriptionDate' field.
   */
  public java.time.Instant getInscriptionDate() {
    return inscriptionDate;
  }


  /**
   * Sets the value of the 'inscriptionDate' field.
   * @param value the value to set.
   */
  public void setInscriptionDate(java.time.Instant value) {
    this.inscriptionDate = value.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
  }

  /**
   * Creates a new Customer RecordBuilder.
   * @return A new Customer RecordBuilder
   */
  public static io.asouquieres.avromodel.Customer.Builder newBuilder() {
    return new io.asouquieres.avromodel.Customer.Builder();
  }

  /**
   * Creates a new Customer RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Customer RecordBuilder
   */
  public static io.asouquieres.avromodel.Customer.Builder newBuilder(io.asouquieres.avromodel.Customer.Builder other) {
    if (other == null) {
      return new io.asouquieres.avromodel.Customer.Builder();
    } else {
      return new io.asouquieres.avromodel.Customer.Builder(other);
    }
  }

  /**
   * Creates a new Customer RecordBuilder by copying an existing Customer instance.
   * @param other The existing instance to copy.
   * @return A new Customer RecordBuilder
   */
  public static io.asouquieres.avromodel.Customer.Builder newBuilder(io.asouquieres.avromodel.Customer other) {
    if (other == null) {
      return new io.asouquieres.avromodel.Customer.Builder();
    } else {
      return new io.asouquieres.avromodel.Customer.Builder(other);
    }
  }

  /**
   * RecordBuilder for Customer instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Customer>
    implements org.apache.avro.data.RecordBuilder<Customer> {

    private long id;
    private java.lang.String commonName;
    private java.lang.String postalCode;
    private java.lang.String adress;
    private java.time.Instant inscriptionDate;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(io.asouquieres.avromodel.Customer.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.commonName)) {
        this.commonName = data().deepCopy(fields()[1].schema(), other.commonName);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.postalCode)) {
        this.postalCode = data().deepCopy(fields()[2].schema(), other.postalCode);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.adress)) {
        this.adress = data().deepCopy(fields()[3].schema(), other.adress);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
      if (isValidValue(fields()[4], other.inscriptionDate)) {
        this.inscriptionDate = data().deepCopy(fields()[4].schema(), other.inscriptionDate);
        fieldSetFlags()[4] = other.fieldSetFlags()[4];
      }
    }

    /**
     * Creates a Builder by copying an existing Customer instance
     * @param other The existing instance to copy.
     */
    private Builder(io.asouquieres.avromodel.Customer other) {
      super(SCHEMA$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.commonName)) {
        this.commonName = data().deepCopy(fields()[1].schema(), other.commonName);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.postalCode)) {
        this.postalCode = data().deepCopy(fields()[2].schema(), other.postalCode);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.adress)) {
        this.adress = data().deepCopy(fields()[3].schema(), other.adress);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.inscriptionDate)) {
        this.inscriptionDate = data().deepCopy(fields()[4].schema(), other.inscriptionDate);
        fieldSetFlags()[4] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * @return The value.
      */
    public long getId() {
      return id;
    }


    /**
      * Sets the value of the 'id' field.
      * @param value The value of 'id'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder setId(long value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder clearId() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'commonName' field.
      * @return The value.
      */
    public java.lang.String getCommonName() {
      return commonName;
    }


    /**
      * Sets the value of the 'commonName' field.
      * @param value The value of 'commonName'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder setCommonName(java.lang.String value) {
      validate(fields()[1], value);
      this.commonName = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'commonName' field has been set.
      * @return True if the 'commonName' field has been set, false otherwise.
      */
    public boolean hasCommonName() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'commonName' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder clearCommonName() {
      commonName = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'postalCode' field.
      * @return The value.
      */
    public java.lang.String getPostalCode() {
      return postalCode;
    }


    /**
      * Sets the value of the 'postalCode' field.
      * @param value The value of 'postalCode'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder setPostalCode(java.lang.String value) {
      validate(fields()[2], value);
      this.postalCode = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'postalCode' field has been set.
      * @return True if the 'postalCode' field has been set, false otherwise.
      */
    public boolean hasPostalCode() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'postalCode' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder clearPostalCode() {
      postalCode = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'adress' field.
      * @return The value.
      */
    public java.lang.String getAdress() {
      return adress;
    }


    /**
      * Sets the value of the 'adress' field.
      * @param value The value of 'adress'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder setAdress(java.lang.String value) {
      validate(fields()[3], value);
      this.adress = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'adress' field has been set.
      * @return True if the 'adress' field has been set, false otherwise.
      */
    public boolean hasAdress() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'adress' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder clearAdress() {
      adress = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'inscriptionDate' field.
      * @return The value.
      */
    public java.time.Instant getInscriptionDate() {
      return inscriptionDate;
    }


    /**
      * Sets the value of the 'inscriptionDate' field.
      * @param value The value of 'inscriptionDate'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder setInscriptionDate(java.time.Instant value) {
      validate(fields()[4], value);
      this.inscriptionDate = value.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'inscriptionDate' field has been set.
      * @return True if the 'inscriptionDate' field has been set, false otherwise.
      */
    public boolean hasInscriptionDate() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'inscriptionDate' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.Customer.Builder clearInscriptionDate() {
      fieldSetFlags()[4] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Customer build() {
      try {
        Customer record = new Customer();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.Long) defaultValue(fields()[0]);
        record.commonName = fieldSetFlags()[1] ? this.commonName : (java.lang.String) defaultValue(fields()[1]);
        record.postalCode = fieldSetFlags()[2] ? this.postalCode : (java.lang.String) defaultValue(fields()[2]);
        record.adress = fieldSetFlags()[3] ? this.adress : (java.lang.String) defaultValue(fields()[3]);
        record.inscriptionDate = fieldSetFlags()[4] ? this.inscriptionDate : (java.time.Instant) defaultValue(fields()[4]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Customer>
    WRITER$ = (org.apache.avro.io.DatumWriter<Customer>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Customer>
    READER$ = (org.apache.avro.io.DatumReader<Customer>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}










